<?php

// start a session
session_start();
error_reporting(E_ALL & ~(E_STRICT|E_NOTICE));
// settings variables
$width = 210;//140;
$height = 40;//60;
if(isset($_SESSION['captcha_image_count'])){
	if($_SESSION['captcha_image_count']>19){
	$_SESSION['captcha_image_count'] -=1;
	}else{
		$_SESSION['captcha_image_count'] = 20;
	}
}
else{
	$_SESSION['captcha_image_count'] = 30;
}
$qvd = $_SESSION['captcha_image_count'];
$blob_width = $qvd;
$blob_height = $qvd;

// image container
$image = imagecreatetruecolor($width, $height);

// background color of the image container
$white = imagecolorallocate($image, 230, 230, 230);
$red  = imagecolorallocate($image, 255, 0, 0);
$blue  = imagecolorallocate($image, 19, 91, 152);
$green  = imagecolorallocate($image, 45, 182, 50);
$gold  = imagecolorallocate($image, 220, 205, 103);
$violet  = imagecolorallocate($image, 208, 50, 214);

// fill the image container
imagefilledrectangle($image, 0, 0, $width, $height ,$white);


// create the spiral pattern on the image container

$theta    = 1;
$thetac   = 7;
$radius   = 16;
$circles  = 40;
$points   = 32;

for ($i = 0; $i < ($circles * $points) - 1; $i++)
{
  $theta = $theta + $thetac;
  $p_r = rand(1,4);
  $rad = ($radius+$p_r) * ($i / $points );
  $x = ($rad * cos($theta)) + $x_axis;
  $y = ($rad * sin($theta)) + $y_axis;
  $theta = $theta + $thetac;
  $rad1 = ($radius+$p_r) * (($i + 1) / $points);
  $x1 = ($rad1 * cos($theta)) + $x_axis;
  $y1 = ($rad1 * sin($theta )) + $y_axis;
  $c = rand(1,3);
  if($c==1){
	  $c = $blue;
  }elseif($c==2){
	  $c = $violet;
  }else{
	  $c = $red;
  }
  imageline($image, $x, $y, $x1, $y1, $c);
  $theta = $theta - $thetac;
}

for ($i = 0; $i < ($circles * $points) - 1; $i++)
{
  $theta = $theta + $thetac;
  $p_r = rand(3,6);
  $rad = ($radius+$p_r) * ($i / $points );
  $x = ($rad * cos($theta)+3) + $x_axis;
  $y = ($rad * sin($theta)+3) + $y_axis;
  $theta = $theta + $thetac;
  $rad1 = ($radius+$p_r) * (($i + 1) / $points);
  $x1 = ($rad1 * cos($theta)) + $x_axis;
  $y1 = ($rad1 * sin($theta )) + $y_axis;
  $c = rand(1,2);
  if($c==1){
	  $c = $green;
  }else{
	  $c = $gold;
  }
  imageline($image, $x, $y, $x1, $y1, $c);
  $theta = $theta - $thetac;
}

// blob location
$x_axis = rand($blob_width, $width) - ($blob_width / 2);
$y_axis = rand($blob_height, $height)  - ($blob_height / 2);

$rand_c = rand(1,6);
if($rand_c==1){
	$rand_c = $white;
}elseif($rand_c==2){
	$rand_c = $red;
}elseif($rand_c==3){
	$rand_c = $gold;
}elseif($rand_c==4){
	$rand_c = $violet;
}else{
	$rand_c = $blue;
}

// render the blob on the image container 
imagefilledellipse ($image, $x_axis, $y_axis, $blob_width, $blob_height, $rand_c);
// create the mask image
$mask_image = imagecreatetruecolor($width, $height);

// background color of the mask image
$mask_white = imagecolorallocate($mask_image, 255, 255, 255);
$mask_red  = imagecolorallocate($mask_image, 255, 0, 0);

// fill the image container
imagefilledrectangle($mask_image, 0, 0, $width, $height ,$mask_white);

// render the blob on the mask image
imagefilledellipse ($mask_image, $x_axis, $y_axis, $blob_width, $blob_height, $mask_red);

// write the mask image to the buffer
ob_start();
imagepng($mask_image);
$mask_image_data = ob_get_contents();  // we retrive the data that was written in the buffer
ob_end_clean();

// convert the image data to Base64
$mask_image_data_b64 =  base64_encode($mask_image_data);

// save the base64 mask image data to the session
$_SESSION['captcha_image_code'] = $mask_image_data_b64;


// Set the content type
header('Content-type: image/jpeg');
header('Cache-control: no-cache');

// render it
imagepng($image);

imagedestroy($image);